﻿using Foundation;
using System;
using System.Collections.Generic;
using System.Text;
using UIKit;
using Xamarin.Forms.Platform.iOS;
using Grouping.iOS.Renderers;
using Grouping.Controls;

[assembly: Xamarin.Forms.ExportRenderer(typeof(HtmlFormattedLabel), typeof(HtmlFormattedLabelRenderer))]

namespace Grouping.iOS.Renderers
{
    public class HtmlFormattedLabelRenderer : ViewRenderer<HtmlFormattedLabel, UILabel>
    {
        protected override void OnElementChanged(ElementChangedEventArgs<HtmlFormattedLabel> e)
        {
            base.OnElementChanged(e);
            try
            {
                var htmlWrapper = "<html><head><title></title><style type='text/css'>body, html {{ font-family: 'San Fransisco', 'Helvetica', Sans-Serif; font-size: 13pt; margin: 0; padding: 0; color:#2b2b2b; }}</style></head><body>{0}</body></html>";

                var view = (HtmlFormattedLabel)Element;
                if (view == null) return;

                if (this.Control == null)
                    SetNativeControl(new UILabel());

                var attr = new NSAttributedStringDocumentAttributes();
                attr.DocumentType = NSDocumentType.HTML;
                attr.StringEncoding = NSStringEncoding.UTF8;

                var nsError = new NSError();

                this.Control.AttributedText = new NSAttributedString(string.Format(htmlWrapper, view.Text), attr, ref nsError);
                this.Control.Lines = 0;
                this.Control.SizeToFit();
            }
            catch (Exception ex)
            {
                // Catch exception so app won't crash
            }
        }
    }
}
    