﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Xamarin.Forms;

namespace Grouping
{
    public class ContactsViewModel : INotifyPropertyChanged
    {

        #region Fields

        private ObservableCollection<Contacts> contactsinfo;
        Random random = new Random();

        #endregion

        #region Properties

        public ObservableCollection<Contacts> ContactItems
        {
            get { return contactsinfo; }
            set
            {
                contactsinfo = value;
                RaisedOnPropertyChanged("ContactItems");
            }
        }
        public ICommand OnRefresh { get; set; }

        private bool isBusy;
        public bool IsBusy
        {
            get
            {
                return isBusy;
            }
            set
            {
                this.isBusy = value;
                RaisedOnPropertyChanged("IsBusy");
            }
        }

        #endregion

        #region Constructor

        public ContactsViewModel()
        {
            contactsinfo = new ObservableCollection<Contacts>();

            this.OnRefresh = new Command(LoadDataAysnc);
        }

        #endregion

        #region Method

        public async void LoadDataAysnc()
        {
            await Task.Delay(1000);

            this.IsBusy = true;
            contactsinfo.Clear();

            for (int i = 0; i < 20; i++)
            {
                var contact = new Contacts();
                contact.ContactNumber = i;
                contact.Text = "<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent lorem ligula, vulputate at turpis ac, venenatis tempus libero. Vivamus eleifend augue in lacus mattis, non porttitor eros auctor. Mauris venenatis at tortor vel finibus. Donec at dignissim diam. Etiam congue ac purus id mollis. Phasellus est libero, egestas sed condimentum in, bibendum ut metus. Maecenas lobortis purus id iaculis dignissim. Aenean accumsan urna vitae sapien ultrices, vel vestibulum ipsum feugiat. Maecenas at commodo massa. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis dignissim dui metus, ac consequat felis ultricies et.</p>";
                contact.Tasks.Add(new TaskItem("Test 1"));
                contact.Tasks.Add(new TaskItem("Test 2"));
                contactsinfo.Add(contact);
            }

            this.IsBusy = false;
        }

        #endregion

        #region INotifyPropertyChanged Interface

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisedOnPropertyChanged(string _PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(_PropertyName));
            }
        }

        #endregion
    }
}
